/*
 * Copyright (C) 2003-2008 eXo Platform SAS.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see<http://www.gnu.org/licenses/>.
 */
package org.exoplatform.services.jcr.integration;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.exoplatform.services.log.Log;

import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SAS.
 * 
 * @author <a href="mailto:Sergey.Kabashnyuk@gmail.com">Sergey Kabashnyuk</a>
 * @version $Id: JCRAPITestSuite.java 33195 2009-06-30 11:04:28Z dkatayev $
 */
public class JCRAPITestSuite extends TestSuite {
  /**
   * Class logger.
   */
  private final Log log = ExoLogger.getLogger("jcr.JCRAPInew");

  public static Test suite() throws InterruptedException {
    return new JCRAPITestSuite();
  }

  public JCRAPITestSuite() {

    TestSuite suite = new TestSuite("javax.jcr init tests");
    suite.addTestSuite(PrepareTestRepository.class);
    addTest(suite);

    addTest(org.apache.jackrabbit.test.api.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.query.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.nodetype.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.util.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.lock.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.version.TestAll.suite());
    addTest(org.apache.jackrabbit.test.api.observation.TestAll.suite());
  }
}
