/*
 * Copyright (C) 2003-2007 eXo Platform SAS.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see<http://www.gnu.org/licenses/>.
 */
package org.exoplatform.services.jcr.lab.cache;

import java.util.HashMap;
import java.util.Map;

import junit.framework.TestCase;

/**
 * Created by The eXo Platform SAS.
 * 
 * <br/>Date: 30.09.2008
 * 
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: TestHashMapConcurrency.java 30997 2009-04-15 13:10:55Z pnedonosko $
 */
public class TestHashMapConcurrency extends TestCase {

  public void testHashMap() throws InterruptedException {

    final Map<String, Object> map = new HashMap<String, Object>();
    // final Map<String, Object> map = Collections.synchronizedMap(new HashMap<String, Object>());

    map.put("key-0", 0);

    Thread th1 = new Thread() {

      /* (non-Javadoc)
       * @see java.lang.Thread#run()
       */
      @Override
      public void run() {
        try {
          // System.out.println(">>>>> in run() waiting 3sec...");
          Thread.sleep(3000);
        } catch (InterruptedException e) {
          e.printStackTrace();
        }

        for (int i = 1; i <= 10; i++) {
          map.put("key-" + i, i);
          // System.out.println("put key-" + i);
        }

        // System.out.println("<<<<< run() done.");
      }
    };

    th1.start();
    synchronized (map) {
      // System.out.println(">>>>>>>>>> synchronized (map)...");
      // System.out.println("map.get " + map.get("key-0"));
      map.get("key-0");
      // Thread.sleep(10000);
      // System.out.println("<<<<<<<<<< synchronized (map).");
    }

  }

}
